/* -----------------------------------------------------------------------
 *
 * Project:     UT-SNMP
 *
 * Filename:    snmpv2_mess.h
 *
 * Date:        April 1994
 *
 * Purpose:     Type definitions and mappings.
 *
 * Author(s):   Rene Oude Vrielink
 *              Vincent Berkhout, Eric van Hengstum
 *
 * -----------------------------------------------------------------------
 */
/*
 *    snmpv2_mess.h
 *
 *    "SNMPv2-MESS" ASN.1 module C type definitions and prototypes
 *
 *    This .h file was by snacc on Mon Feb 28 13:08:38 1994
 *
 *    UBC snacc written compiler by Mike Sample
 *
 *    NOTE: This is a machine generated file - editing not recommended
 */


#ifndef _snmpv2_mess_h_
#define _snmpv2_mess_h_


/* 
 * -----------------------------------------------------------------------
 *
 * 	error-status            -- sometimes ignored
 *		INTEGER {
 * 			noError(0), tooBig(1), noSuchName(2), badValue(3),
 *			readOnly(4), genErr(5), noAccess(6), wrongType(7),
 *			wrongLength(8), wrongEncoding(9), wrongValue(10),
 *			noCreation(11), inconsistentValue(12), resourceUnavailable(13),
 *			commitFailed(14), undoFailed(15), authorizationError(16),
 *			notWritable(17), inconsistentName(18) },
 *
 * -----------------------------------------------------------------------
 */

#ifdef NOERROR 
#undef NOERROR
#endif

#define NOERROR 0 		/* this line was marked! (Rob) */
#define TOOBIG 1
#define NOSUCHNAME 2
#define BADVALUE 3
#define READONLY 4
#define GENERR 5
#define NOACCESS 6
#define WRONGTYPE 7
#define WRONGLENGTH 8
#define WRONGENCODING 9
#define WRONGVALUE 10
#define NOCREATION 11
#define INCONSISTENTVALUE 12
#define RESOURCEUNAVAILABLE 13
#define COMMITFAILED 14
#define UNDOFAILED 15
#define AUTHORIZATIONERROR 16
#define NOTWRITABLE 17
#define INCONSISTENTNAME 18
#define NOUNDOERROR 19
#define NOCOMMITERROR 20


typedef AsnInt PDUInt; 

#define BEncPDUIntContent BEncAsnIntContent

#define BDecPDUIntContent BDecAsnIntContent

#define PrintPDUInt PrintAsnInt

#define FreePDUInt FreeAsnInt 



/* 
 * -----------------------------------------------------------------------
 *
 * 	-- names of objects
 *
 *	ObjectName ::=
 *		OBJECT IDENTIFIER
 *
 * -----------------------------------------------------------------------
 */

typedef AsnOid ObjectName; /* OBJECT IDENTIFIER */

#define BEncObjectNameContent BEncAsnOidContent

#define BDecObjectNameContent BDecAsnOidContent

#define PrintObjectName PrintAsnOid

#define FreeObjectName FreeAsnOid 



/* 
 * -----------------------------------------------------------------------
 *
 *	-- indistinguishable from INTEGER, but never needs more than
 *	-- 32-bits for a two's complement representation
 *
 *	Integer32 ::=
 *		[UNIVERSAL 2]
 *			IMPLICIT INTEGER (-2147483648..2147483647)
 *
 * -----------------------------------------------------------------------
 */

typedef AsnInt Integer32; /* IMPLICIT INTEGER (-2147483648..2147483647) */

#define BEncInteger32Content BEncAsnIntContent

#define BDecInteger32Content BDecAsnIntContent

#define PrintInteger32 PrintAsnInt

#define FreeInteger32 FreeAsnInt 



/* 
 * -----------------------------------------------------------------------
 *
 *	-- in network-byte order
 *	-- (this is a tagged type for historical reasons)
 *	
 *	IpAddress ::=
 *		[APPLICATION 0]
 *			IMPLICIT OCTET STRING (SIZE (4))
 *
 * -----------------------------------------------------------------------
 */

typedef AsnOcts IpAddress; /* [APPLICATION 0] IMPLICIT OCTET STRING (SIZE (4)) */

#define BEncIpAddressContent BEncAsnOctsContent

#define BDecIpAddressContent BDecAsnOctsContent

#define PrintIpAddress PrintAsnOcts

#define FreeIpAddress FreeAsnOcts 



/* 
 * -----------------------------------------------------------------------
 *
 *	-- this wraps
 *
 *	Counter32 ::= --snacc cTypeName "unsigned long int"
 *		[APPLICATION 1]
 *			IMPLICIT INTEGER  (0..4294967295)
 *
 * -----------------------------------------------------------------------
 */

typedef UAsnInt Counter32; /* [APPLICATION 1] IMPLICIT INTEGER (0..-1) */

#define BEncCounter32Content BEncUAsnIntContent

#define BDecCounter32Content BDecUAsnIntContent

#define PrintCounter32 PrintUAsnInt

#define FreeCounter32 FreeUAsnInt 



/* 
 * -----------------------------------------------------------------------
 *
 *	-- this doesn't wrap
 *
 *	Gauge32 ::=
 *		[APPLICATION 2]
 *			IMPLICIT INTEGER (0..4294967295)
 *
 * -----------------------------------------------------------------------
 */

typedef UAsnInt Gauge32; /* [APPLICATION 2] IMPLICIT INTEGER (0..-1) */

#define BEncGauge32Content BEncUAsnIntContent

#define BDecGauge32Content BDecUAsnIntContent

#define PrintGauge32 PrintUAsnInt

#define FreeGauge32 FreeUAsnInt 



/* 
 * -----------------------------------------------------------------------
 *
 *	-- hundredths of seconds since an epoch
 *
 * 	TimeTicks ::=
 *		[APPLICATION 3]
 *			IMPLICIT INTEGER (0..4294967295)
 *
 * -----------------------------------------------------------------------
 */

typedef UAsnInt TimeTicks; /* [APPLICATION 3] IMPLICIT INTEGER (0..-1) */

#define BEncTimeTicksContent BEncUAsnIntContent

#define BDecTimeTicksContent BDecUAsnIntContent

#define PrintTimeTicks PrintUAsnInt

#define FreeTimeTicks FreeUAsnInt 



/* 
 * -----------------------------------------------------------------------
 *
 *	-- for backward-compatibility only
 *
 *	Opaque ::=
 *		[APPLICATION 4]
 *			IMPLICIT OCTET STRING
 *
 * -----------------------------------------------------------------------
 */

typedef AsnOcts Opaque; /* [APPLICATION 4] IMPLICIT OCTET STRING */

#define BEncOpaqueContent BEncAsnOctsContent

#define BDecOpaqueContent BDecAsnOctsContent

#define PrintOpaque PrintAsnOcts

#define FreeOpaque FreeAsnOcts 



/* 
 * -----------------------------------------------------------------------
 *
 *	-- for OSI NSAP addresses
 * 	-- (this is a tagged type for historical reasons)
 *
 *	NsapAddress ::=
 *		[APPLICATION 5]
 *			IMPLICIT OCTET STRING (SIZE (1 | 4..21))
 *
 * -----------------------------------------------------------------------
 */

typedef AsnOcts NsapAddress; /* [APPLICATION 5] IMPLICIT OCTET STRING (SIZE (1) | (4..21)) */

#define BEncNsapAddressContent BEncAsnOctsContent

#define BDecNsapAddressContent BDecAsnOctsContent

#define PrintNsapAddress PrintAsnOcts

#define FreeNsapAddress FreeAsnOcts 



/* 
 * -----------------------------------------------------------------------
 *
 *	-- for counters that wrap in less than one hour with only 32 bits
 *	
 *	Counter64 ::=
 *		[APPLICATION 6]
 *			IMPLICIT INTEGER (0..18446744073709551615)
 *
 * -----------------------------------------------------------------------
 */

typedef UAsnInt Counter64; /* [APPLICATION 6] IMPLICIT INTEGER (0..-1) */

#define BEncCounter64Content BEncUAsnIntContent

#define BDecCounter64Content BDecUAsnIntContent

#define PrintCounter64 PrintUAsnInt

#define FreeCounter64 FreeUAsnInt 



/* 
 * -----------------------------------------------------------------------
 *
 *	-- an unsigned 32-bit quantity
 *
 *	UInteger32 ::=
 *		[APPLICATION 7]
 *			IMPLICIT INTEGER (0..4294967295)
 *
 * -----------------------------------------------------------------------
 */

typedef UAsnInt UInteger32; /* [APPLICATION 7] IMPLICIT INTEGER (0..-1) */

#define BEncUInteger32Content BEncUAsnIntContent

#define BDecUInteger32Content BDecUAsnIntContent

#define PrintUInteger32 PrintUAsnInt

#define FreeUInteger32 FreeUAsnInt 



/* 
 * -----------------------------------------------------------------------
 *
 *	operation
 *		CHOICE {
 *			get-request
 *				[0] IMPLICIT OCTET STRING,
 *			get-next-request
 *				[1] IMPLICIT OCTET STRING,
 *			response
 *				[2] IMPLICIT OCTET STRING,
 *			set-request
 *				[3] IMPLICIT OCTET STRING,
 *			get-bulk-request
 *				[5] IMPLICIT OCTET STRING,
 *			inform-request
 *				[6] IMPLICIT OCTET STRING,
 *			snmpV2-trap
 *				[7] IMPLICIT OCTET STRING
 *		}
 *
 * -----------------------------------------------------------------------
 */
typedef enum SnmpMgmtComChoiceChoiceId
    {
        SNMPMGMTCOMCHOICE_GET_REQUEST = 0,
        SNMPMGMTCOMCHOICE_GET_NEXT_REQUEST = 1,
        SNMPMGMTCOMCHOICE_RESPONSE = 2,
        SNMPMGMTCOMCHOICE_SET_REQUEST = 3,
        SNMPMGMTCOMCHOICE_GET_BULK_REQUEST = 5,
        SNMPMGMTCOMCHOICE_INFORM_REQUEST = 6,
        SNMPMGMTCOMCHOICE_SNMPV2_TRAP = 7
} SnmpMgmtComChoiceChoiceId;


typedef struct SnmpMgmtComChoice /* CHOICE */
{
    SnmpMgmtComChoiceChoiceId  choiceId;
    union SnmpMgmtComChoiceChoiceUnion
    {
    AsnOcts* get_request; /* [0] IMPLICIT OCTET STRING */
    AsnOcts* get_next_request; /* [1] IMPLICIT OCTET STRING */
    AsnOcts* response; /* [2] IMPLICIT OCTET STRING */
    AsnOcts* set_request; /* [3] IMPLICIT OCTET STRING */
    AsnOcts* get_bulk_request; /* [5] IMPLICIT OCTET STRING */
    AsnOcts* inform_request; /* [6] IMPLICIT OCTET STRING */
    AsnOcts* snmpV2_trap; /* [7] IMPLICIT OCTET STRING */
    } a;
} SnmpMgmtComChoice;

AsnLen BEncSnmpMgmtComChoiceContent (BUF_TYPE b, SnmpMgmtComChoice* v);

void BDecSnmpMgmtComChoiceContent ( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, SnmpMgmtComChoice* v, AsnLen* bytesDecoded, ENV_TYPE env);

void PrintSnmpMgmtComChoice (FILE* f, SnmpMgmtComChoice* v, unsigned short int indent);

void FreeSnmpMgmtComChoice (SnmpMgmtComChoice* v);



/* 
 * -----------------------------------------------------------------------
 *
 *	v2md5AuthProtocol
 *		[2] IMPLICIT SEQUENCE {
 *			authDigest
 *				OCTET STRING (SIZE(16)),
 *			authDstTimestamp
 *				UInteger32,
 *			authSrcTimestamp
 *				UInteger32
 *		}
 *
 * -----------------------------------------------------------------------
 */

typedef struct SnmpAuthMsgChoiceSeq /* SEQUENCE */
{
    AsnOcts authDigest; /* OCTET STRING (SIZE (16)) */
    UInteger32 authDstTimestamp; /* UInteger32 */
    UInteger32 authSrcTimestamp; /* UInteger32 */
} SnmpAuthMsgChoiceSeq;

AsnLen BEncSnmpAuthMsgChoiceSeqContent (BUF_TYPE b, SnmpAuthMsgChoiceSeq* v);

void BDecSnmpAuthMsgChoiceSeqContent ( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, SnmpAuthMsgChoiceSeq* v, AsnLen* bytesDecoded, ENV_TYPE env);

void PrintSnmpAuthMsgChoiceSeq (FILE* f, SnmpAuthMsgChoiceSeq* v, unsigned short int indent);
void FreeSnmpAuthMsgChoiceSeq (SnmpAuthMsgChoiceSeq* v);



/* 
 * -----------------------------------------------------------------------
 *
 *	CHOICE {
 *		noAuth
 *			OCTET STRING(SIZE(0)),
 *		v2md5AuthProtocol
 *			...
 *	}
 *
 * -----------------------------------------------------------------------
 */

typedef enum SnmpAuthMsgChoiceChoiceId 
    {
        SNMPAUTHMSGCHOICE_NOAUTH,
        SNMPAUTHMSGCHOICE_V2MD5AUTHPROTOCOL
} SnmpAuthMsgChoiceChoiceId;

typedef struct SnmpAuthMsgChoice /* CHOICE */
{
    SnmpAuthMsgChoiceChoiceId choiceId;
    union SnmpAuthMsgChoiceChoiceUnion
    {
    AsnOcts* noAuth; /* OCTET STRING (SIZE (0)) */
    struct SnmpAuthMsgChoiceSeq* v2md5AuthProtocol; /* [2] IMPLICIT SnmpAuthMsgChoiceSeq */
    } a;
} SnmpAuthMsgChoice;

AsnLen BEncSnmpAuthMsgChoiceContent (BUF_TYPE b, SnmpAuthMsgChoice* v);

void BDecSnmpAuthMsgChoiceContent ( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, SnmpAuthMsgChoice* v, AsnLen* bytesDecoded, ENV_TYPE env);


void PrintSnmpAuthMsgChoice (FILE* f, SnmpAuthMsgChoice* v, unsigned short int indent);
void FreeSnmpAuthMsgChoice (SnmpAuthMsgChoice* v);



/* 
 * -----------------------------------------------------------------------
 *
 *	-- syntax of objects
 *
 *	ObjectSyntax ::=
 *		CHOICE {
 *			-- INTEGERs with a more restrictive range
 *			-- may also be used
 *			integer-value
 *				INTEGER (-2147483648..2147483647),
 *			string-value
 *				OCTET STRING,
 *			objectID-value
 *				OBJECT IDENTIFIER,
 *			bit-value
 *				BIT STRING,
 *			ipAddress-value
 *				IpAddress,
 *			counter-value
 *				Counter32,
 *			gauge-value
 *				Gauge32,
 *			timeticks-value
 *				TimeTicks,
 *			arbitrary-value
 *				Opaque,
 *			nsapAddress-value
 *				NsapAddress,
 *			big-counter-value
 *				Counter64,
 *			unsigned-integer-value
 *				UInteger32
 *		}
 *
 * -----------------------------------------------------------------------
 */

typedef enum ObjectSyntaxChoiceId
{
    OBJECTSYNTAX_INTEGER_VALUE,
    OBJECTSYNTAX_STRING_VALUE,
    OBJECTSYNTAX_OBJECTID_VALUE,
    OBJECTSYNTAX_BIT_VALUE,
    OBJECTSYNTAX_IPADDRESS_VALUE,
    OBJECTSYNTAX_COUNTER_VALUE,
    OBJECTSYNTAX_GAUGE_VALUE,
    OBJECTSYNTAX_TIMETICKS_VALUE,
    OBJECTSYNTAX_ARBITRARY_VALUE,
    OBJECTSYNTAX_NSAPADDRESS_VALUE,
    OBJECTSYNTAX_BIG_COUNTER_VALUE,
    OBJECTSYNTAX_UNSIGNED_INTEGER_VALUE
} ObjectSyntaxChoiceId;

typedef struct ObjectSyntax /* CHOICE */
{
    ObjectSyntaxChoiceId choiceId;
    union ObjectSyntaxChoiceUnion
    {
    AsnInt integer_value; /* INTEGER (-2147483648..2147483647) */
    AsnOcts* string_value; /* OCTET STRING */
    AsnOid* objectID_value; /* OBJECT IDENTIFIER */
    AsnBits* bit_value; /* BIT STRING */
    IpAddress* ipAddress_value; /* IpAddress */
    Counter32 counter_value; /* Counter32 */
    Gauge32 gauge_value; /* Gauge32 */
    TimeTicks timeticks_value; /* TimeTicks */
    Opaque* arbitrary_value; /* Opaque */
    NsapAddress* nsapAddress_value; /* NsapAddress */
    Counter64 big_counter_value; /* Counter64 */
    UInteger32 unsigned_integer_value; /* UInteger32 */
    } a;
} ObjectSyntax;

AsnLen BEncObjectSyntaxContent (BUF_TYPE b, ObjectSyntax* v);

void BDecObjectSyntaxContent ( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, ObjectSyntax* v, AsnLen* bytesDecoded, ENV_TYPE env);

void PrintObjectSyntax (FILE* f, ObjectSyntax* v, unsigned short int indent);

void FreeObjectSyntax (ObjectSyntax* v);



/* 
 * -----------------------------------------------------------------------
 *
 *	CHOICE {
 *		value
 *			ObjectSyntax,
 *		unSpecified         -- in retrieval requests
 *			NULL,
 *		noSuchObject[0]
 *			IMPLICIT NULL,
 *		noSuchInstance[1]
 *			IMPLICIT NULL,
 *		endOfMibView[2]
 *			IMPLICIT NULL
 *	}
 *
 * -----------------------------------------------------------------------
 */

typedef enum VarBindChoiceChoiceId
{
    VARBINDCHOICE_VALUE,
    VARBINDCHOICE_UNSPECIFIED,
    VARBINDCHOICE_NOSUCHOBJECT,
    VARBINDCHOICE_NOSUCHINSTANCE,
    VARBINDCHOICE_ENDOFMIBVIEW
} VarBindChoiceChoiceId;

typedef struct VarBindChoice /* CHOICE */
{
    VarBindChoiceChoiceId choiceId;
    union VarBindChoiceChoiceUnion
    {
    struct ObjectSyntax* value; /* ObjectSyntax */
    AsnNull unSpecified; /* NULL */
    AsnNull noSuchObject; /* [0] IMPLICIT NULL */
    AsnNull noSuchInstance; /* [1] IMPLICIT NULL */
    AsnNull endOfMibView; /* [2] IMPLICIT NULL */
    } a;
} VarBindChoice;

AsnLen BEncVarBindChoiceContent (BUF_TYPE b, VarBindChoice* v);

void BDecVarBindChoiceContent ( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, VarBindChoice* v, AsnLen* bytesDecoded, ENV_TYPE env);

void PrintVarBindChoice (FILE* f, VarBindChoice* v, unsigned short int indent);

void FreeVarBindChoice (VarBindChoice* v);



/* 
 * -----------------------------------------------------------------------
 *
 *	-- variable binding
 *
 *	VarBind ::= --snacc isPdu:"TRUE" --
 *		SEQUENCE {
 *			name
 *				ObjectName,
 *			CHOICE {
 *				value
 *					ObjectSyntax,
 *				unSpecified         -- in retrieval requests
 *					NULL,
 *				-- exceptions in responses
 *				noSuchObject[0]
 *					IMPLICIT NULL,
 *				noSuchInstance[1]
 *					IMPLICIT NULL,
 *				endOfMibView[2]
 *					IMPLICIT NULL
 *			}
 *		}
 *
 * -----------------------------------------------------------------------
 */

typedef struct VarBind /* SEQUENCE */
{
    ObjectName name; /* ObjectName */
    struct VarBindChoice* varBindChoice; /* VarBindChoice */
} VarBind;

AsnLen BEncVarBind (BUF_TYPE b, VarBind* v);

void BDecVarBind ( BUF_TYPE b, VarBind* result, AsnLen* bytesDecoded, ENV_TYPE env);

AsnLen BEncVarBindContent (BUF_TYPE b, VarBind* v);

void BDecVarBindContent ( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, VarBind* v, AsnLen* bytesDecoded, ENV_TYPE env);

void PrintVarBind (FILE* f, VarBind* v, unsigned short int indent);

void FreeVarBind (VarBind* v);




/* 
 * -----------------------------------------------------------------------
 *
 *	-- variable-binding list
 *
 *	VarBindList ::= --snacc isPdu:"TRUE" --
 *		SEQUENCE  OF
 *			VarBind
 *
 * -----------------------------------------------------------------------
 */

typedef AsnList VarBindList; /* SEQUENCE OF VarBind */

AsnLen BEncVarBindList (BUF_TYPE b, VarBindList* v);

void BDecVarBindList ( BUF_TYPE b, VarBindList* result, AsnLen* bytesDecoded, ENV_TYPE env);

AsnLen BEncVarBindListContent (BUF_TYPE b, VarBindList* v);

void BDecVarBindListContent ( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, VarBindList* v, AsnLen* bytesDecoded, ENV_TYPE env);

void PrintVarBindList (FILE* f, VarBindList* v, unsigned short int indent);

void FreeVarBindList (VarBindList* v);


/* 
 * -----------------------------------------------------------------------
 *
 *	PDU ::= --snacc isPdu:"TRUE" --
 *		SEQUENCE {
 *			request-id
 *				Integer32,
 *			error-status 
 *				INTEGER ...
 *			error-index  
 *				INTEGER (0..max-bindings),
 *			variable-bindings
 *				VarBindList
 *		}
 *
 * -----------------------------------------------------------------------
 */

typedef struct PDU /* SEQUENCE */
{
    Integer32 request_id; /* Integer32 */
    PDUInt error_status; /* PDUInt */
    AsnInt error_index; /* INTEGER (0..max-bindings) */
    VarBindList* variable_bindings; /* VarBindList */
} PDU;

AsnLen BEncPDU (BUF_TYPE b, PDU* v);

void BDecPDU ( BUF_TYPE b, PDU* result, AsnLen* bytesDecoded, ENV_TYPE env);

AsnLen BEncPDUContent (BUF_TYPE b, PDU* v);

void BDecPDUContent ( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, PDU* v, AsnLen* bytesDecoded, ENV_TYPE env);

void PrintPDU (FILE* f, PDU* v, unsigned short int indent);

void FreePDU (PDU* v);



/* 
 * -----------------------------------------------------------------------
 *
 *	BulkPDU ::= --snacc isPdu:"TRUE" -- -- MUST be identical in
 *		SEQUENCE {                      -- structure to PDU
 *			request-id
 *				Integer32,
 *			non-repeaters
 *				INTEGER (0..max-bindings),
 *			max-repetitions
 *				INTEGER (0..max-bindings),
 *			variable-bindings       -- values are ignored
 *				VarBindList
 *		}
 *
 * -----------------------------------------------------------------------
 */

typedef struct BulkPDU /* SEQUENCE */
{
    Integer32 request_id; /* Integer32 */
    AsnInt non_repeaters; /* INTEGER (0..max-bindings) */
    AsnInt max_repetitions; /* INTEGER (0..max-bindings) */
    VarBindList* variable_bindings; /* VarBindList */
} BulkPDU;

AsnLen BEncBulkPDU (BUF_TYPE b, BulkPDU* v);

void BDecBulkPDU ( BUF_TYPE b, BulkPDU* result, AsnLen* bytesDecoded, ENV_TYPE env);

AsnLen BEncBulkPDUContent (BUF_TYPE b, BulkPDU* v);

void BDecBulkPDUContent ( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, BulkPDU* v, AsnLen* bytesDecoded, ENV_TYPE env);

void PrintBulkPDU (FILE* f, BulkPDU* v, unsigned short int indent);

void FreeBulkPDU (BulkPDU* v);



/* 
 * -----------------------------------------------------------------------
 *
 *	GetRequest-PDU ::= --snacc isPdu:"TRUE" --
 *		[0]
 *			IMPLICIT PDU
 *
 * -----------------------------------------------------------------------
 */

typedef struct PDU GetRequest_PDU; /* [0] IMPLICIT PDU */

AsnLen BEncGetRequest_PDU (BUF_TYPE b, GetRequest_PDU* v);

void BDecGetRequest_PDU ( BUF_TYPE b, GetRequest_PDU* result, AsnLen* bytesDecoded, ENV_TYPE env);
#define BEncGetRequest_PDUContent BEncPDUContent

#define BDecGetRequest_PDUContent BDecPDUContent

#define PrintGetRequest_PDU PrintPDU

#define FreeGetRequest_PDU FreePDU 




/* 
 * -----------------------------------------------------------------------
 *
 *	GetNextRequest-PDU ::= --snacc isPdu:"TRUE" --
 *		[1]
 *			IMPLICIT PDU
 *
 * -----------------------------------------------------------------------
 */

typedef struct PDU GetNextRequest_PDU; /* [1] IMPLICIT PDU */

AsnLen BEncGetNextRequest_PDU (BUF_TYPE b, GetNextRequest_PDU* v);

void BDecGetNextRequest_PDU ( BUF_TYPE b, GetNextRequest_PDU* result, AsnLen* bytesDecoded, ENV_TYPE env);

#define BEncGetNextRequest_PDUContent BEncPDUContent

#define BDecGetNextRequest_PDUContent BDecPDUContent

#define PrintGetNextRequest_PDU PrintPDU

#define FreeGetNextRequest_PDU FreePDU 



/* 
 * -----------------------------------------------------------------------
 *
 *	Response-PDU ::= --snacc isPdu:"TRUE" --
 *		[2]
 *			IMPLICIT PDU
 *
 * -----------------------------------------------------------------------
 */

typedef struct PDU Response_PDU; /* [2] IMPLICIT PDU */

AsnLen BEncResponse_PDU (BUF_TYPE b, Response_PDU* v);

void BDecResponse_PDU ( BUF_TYPE b, Response_PDU* result, AsnLen* bytesDecoded, ENV_TYPE env);
#define BEncResponse_PDUContent BEncPDUContent

#define BDecResponse_PDUContent BDecPDUContent

#define PrintResponse_PDU PrintPDU


#define FreeResponse_PDU FreePDU 



/* 
 * -----------------------------------------------------------------------
 *
 *	SetRequest-PDU ::= --snacc isPdu:"TRUE" --
 *		[3]
 *			IMPLICIT PDU
 *
 * -----------------------------------------------------------------------
 */

typedef struct PDU SetRequest_PDU; /* [3] IMPLICIT PDU */

AsnLen BEncSetRequest_PDU (BUF_TYPE b, SetRequest_PDU* v);

void BDecSetRequest_PDU ( BUF_TYPE b, SetRequest_PDU* result, AsnLen* bytesDecoded, ENV_TYPE env);

#define BEncSetRequest_PDUContent BEncPDUContent

#define BDecSetRequest_PDUContent BDecPDUContent

#define PrintSetRequest_PDU PrintPDU

#define FreeSetRequest_PDU FreePDU 




/* 
 * -----------------------------------------------------------------------
 *
 *	GetBulkRequest-PDU ::= --snacc isPdu:"TRUE" --
 *		[5]
 *			IMPLICIT BulkPDU
 *
 * -----------------------------------------------------------------------
 */

typedef struct BulkPDU GetBulkRequest_PDU; /* [5] IMPLICIT BulkPDU */

AsnLen BEncGetBulkRequest_PDU (BUF_TYPE b, GetBulkRequest_PDU* v);

void BDecGetBulkRequest_PDU ( BUF_TYPE b, GetBulkRequest_PDU* result, AsnLen* bytesDecoded, ENV_TYPE env);

#define BEncGetBulkRequest_PDUContent BEncBulkPDUContent

#define BDecGetBulkRequest_PDUContent BDecBulkPDUContent

#define PrintGetBulkRequest_PDU PrintBulkPDU

#define FreeGetBulkRequest_PDU FreeBulkPDU 




/* 
 * -----------------------------------------------------------------------
 *
 *	InformRequest-PDU ::= --snacc isPdu:"TRUE" --
 *		[6]
 *			IMPLICIT PDU
 *
 * -----------------------------------------------------------------------
 */

typedef struct PDU InformRequest_PDU; /* [6] IMPLICIT PDU */

AsnLen BEncInformRequest_PDU (BUF_TYPE b, InformRequest_PDU* v);

void BDecInformRequest_PDU ( BUF_TYPE b, InformRequest_PDU* result, AsnLen* bytesDecoded, ENV_TYPE env);

#define BEncInformRequest_PDUContent BEncPDUContent

#define BDecInformRequest_PDUContent BDecPDUContent

#define PrintInformRequest_PDU PrintPDU

#define FreeInformRequest_PDU FreePDU 




/* 
 * -----------------------------------------------------------------------
 *
 *	SNMPv2-Trap-PDU ::= --snacc isPdu:"TRUE" --
 *		[7]
 *			IMPLICIT PDU
 *
 * -----------------------------------------------------------------------
 */

typedef struct PDU SNMPv2_Trap_PDU; /* [7] IMPLICIT PDU */

AsnLen BEncSNMPv2_Trap_PDU (BUF_TYPE b, SNMPv2_Trap_PDU* v);

void BDecSNMPv2_Trap_PDU ( BUF_TYPE b, SNMPv2_Trap_PDU* result, AsnLen* bytesDecoded, ENV_TYPE env);

#define BEncSNMPv2_Trap_PDUContent BEncPDUContent

#define BDecSNMPv2_Trap_PDUContent BDecPDUContent

#define PrintSNMPv2_Trap_PDU PrintPDU

#define FreeSNMPv2_Trap_PDU FreePDU 




/* 
 * -----------------------------------------------------------------------
 *
 *	SnmpPrivMsg ::= --snacc isPdu:"TRUE" --
 *		[1] IMPLICIT SEQUENCE {
 *			privDst
 *				OBJECT IDENTIFIER,
 *			privData
 *				[1] IMPLICIT OCTET STRING
 *		}
 *
 * -----------------------------------------------------------------------
 */

typedef struct SnmpPrivMsg /* [1] IMPLICIT SEQUENCE */
{
    AsnOid privDst; /* OBJECT IDENTIFIER */
    AsnOcts privData; /* [1] IMPLICIT OCTET STRING */
} SnmpPrivMsg;

AsnLen BEncSnmpPrivMsg (BUF_TYPE b, SnmpPrivMsg* v);

void BDecSnmpPrivMsg ( BUF_TYPE b, SnmpPrivMsg* result, AsnLen* bytesDecoded, ENV_TYPE env);
AsnLen BEncSnmpPrivMsgContent (BUF_TYPE b, SnmpPrivMsg* v);

void BDecSnmpPrivMsgContent ( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, SnmpPrivMsg* v, AsnLen* bytesDecoded, ENV_TYPE env);

void PrintSnmpPrivMsg (FILE* f, SnmpPrivMsg* v, unsigned short int indent);
void FreeSnmpPrivMsg (SnmpPrivMsg* v);




/* 
 * -----------------------------------------------------------------------
 *
 *	SnmpAuthMsg ::= --snacc isPdu:"TRUE" --
 *		[1] IMPLICIT SEQUENCE {
 *			authInfo
 *				...
 *			authData
 *				[2] IMPLICIT OCTET STRING
 *		}
 *
 * -----------------------------------------------------------------------
 */

typedef struct SnmpAuthMsg /* [1] IMPLICIT SEQUENCE */
{
    struct SnmpAuthMsgChoice* authInfo; /* SnmpAuthMsgChoice */
    AsnOcts authData; /* [2] IMPLICIT OCTET STRING */
} SnmpAuthMsg;

AsnLen BEncSnmpAuthMsg (BUF_TYPE b, SnmpAuthMsg* v);

void BDecSnmpAuthMsg ( BUF_TYPE b, SnmpAuthMsg* result, AsnLen* bytesDecoded, ENV_TYPE env);
AsnLen BEncSnmpAuthMsgContent (BUF_TYPE b, SnmpAuthMsg* v);

void BDecSnmpAuthMsgContent ( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, SnmpAuthMsg* v, AsnLen* bytesDecoded, ENV_TYPE env);

void PrintSnmpAuthMsg (FILE* f, SnmpAuthMsg* v, unsigned short int indent);
void FreeSnmpAuthMsg (SnmpAuthMsg* v);



/* 
 * -----------------------------------------------------------------------
 *
 *	SnmpMgmtCom ::= --snacc isPdu:"TRUE" --
 *		[2] IMPLICIT SEQUENCE {
 *			dstParty
 *				OBJECT IDENTIFIER,
 *			srcParty
 *				OBJECT IDENTIFIER,
 *			context
 *				OBJECT IDENTIFIER,
 *			operation
 *				...
 *		}
 *
 * -----------------------------------------------------------------------
 */

typedef struct SnmpMgmtCom /* [2] IMPLICIT SEQUENCE */
{
    AsnOid dstParty; /* OBJECT IDENTIFIER */
    AsnOid srcParty; /* OBJECT IDENTIFIER */
    AsnOid context; /* OBJECT IDENTIFIER */
    struct SnmpMgmtComChoice* operation; /* SnmpMgmtComChoice */
} SnmpMgmtCom;

AsnLen BEncSnmpMgmtCom (BUF_TYPE b, SnmpMgmtCom* v);

void BDecSnmpMgmtCom ( BUF_TYPE b, SnmpMgmtCom* result, AsnLen* bytesDecoded, ENV_TYPE env);
AsnLen BEncSnmpMgmtComContent (BUF_TYPE b, SnmpMgmtCom* v);

void BDecSnmpMgmtComContent ( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, SnmpMgmtCom* v, AsnLen* bytesDecoded, ENV_TYPE env);


void PrintSnmpMgmtCom (FILE* f, SnmpMgmtCom* v, unsigned short int indent);
void FreeSnmpMgmtCom (SnmpMgmtCom* v);



/* 
 * -----------------------------------------------------------------------
 *
 *	PDUs ::= --snacc isPdu:"TRUE" --
 *		CHOICE {
 *			get-request
 *				GetRequest-PDU,
 *			get-next-request
 *				GetNextRequest-PDU,
 *			response
 *				Response-PDU,
 *			set-request
 *				SetRequest-PDU,
 *			get-bulk-request
 *				GetBulkRequest-PDU,
 *			inform-request
 *				InformRequest-PDU,
 *			snmpV2-trap
 *				SNMPv2-Trap-PDU
 *	 	}
 *
 * -----------------------------------------------------------------------
 */

typedef enum PDUsChoiceId
   {
	PDUS_GET_REQUEST = 0, PDUS_GET_NEXT_REQUEST = 1, PDUS_RESPONSE = 2,
	PDUS_SET_REQUEST = 3, PDUS_TRAP = 4, PDUS_GET_BULK_REQUEST = 5,
	PDUS_INFORM_REQUEST = 6, PDUS_SNMPV2_TRAP = 7 
} PDUsChoiceId;

typedef struct PDUs /* CHOICE */
{
    PDUsChoiceId choiceId;
    union PDUsChoiceUnion
    {
    GetRequest_PDU* get_request; /* GetRequest-PDU */
    GetNextRequest_PDU* get_next_request; /* GetNextRequest-PDU */
    Response_PDU* response; /* Response-PDU */
    SetRequest_PDU* set_request; /* SetRequest-PDU */
    GetBulkRequest_PDU* get_bulk_request; /* GetBulkRequest-PDU */
    InformRequest_PDU* inform_request; /* InformRequest-PDU */
    SNMPv2_Trap_PDU* snmpV2_trap; /* SNMPv2-Trap-PDU */
    } a;
} PDUs;

AsnLen BEncPDUs (BUF_TYPE b, PDUs* v);

void BDecPDUs ( BUF_TYPE b, PDUs* result, AsnLen* bytesDecoded, ENV_TYPE env);
AsnLen BEncPDUsContent (BUF_TYPE b, PDUs* v);

void BDecPDUsContent ( BUF_TYPE b, AsnTag tagId0, AsnLen elmtLen0, PDUs* v, AsnLen* bytesDecoded, ENV_TYPE env);


void PrintPDUs (FILE* f, PDUs* v, unsigned short int indent);
void FreePDUs (PDUs* v);

/*
 * 	These oids are moved to snmpConst.h
 * 	Vincent Berkhout v2_1
 *
extern AsnInt max_bindings;
extern AsnOid internet;
extern AsnOid directory;
extern AsnOid mgmt;
extern AsnOid experimental;
extern AsnOid private;
extern AsnOid enterprises;
extern AsnOid security;
extern AsnOid snmpV2;
extern AsnOid snmpDomains;
extern AsnOid snmpProxys;
extern AsnOid snmpModules;
 *
 */

#endif /* conditional include of snmpv2_mess.h */


/* -----------------------------------------------------------------------
 */
