/* -----------------------------------------------------------------------
 *
 * Project:     UT-SNMP
 *
 * Filename:    spmHash.h
 *
 * Date:        April 1994
 *
 * Purpose:     This file contains the primairy hashing functions.
 *
 * Author( s):  Koert W. G. Flapper
 *
 * -----------------------------------------------------------------------
 */
      
/* hash.h */
#ifndef HASH_H
#define HASH_H

#include <snmpTypes.h>


struct Hashnode {				/* hash table node structure */
	void	*pentry;			/* points to a party-entry */
	struct Hashnode		*pnext;		/* next node in hash bucket */
};

/* -----------------------------------------------------------------------
 * Function:    hashoid
 * Arguments:   
 * Purpose:     hash an object identifier to a hashtable entry
 * Remarks:     
 * -----------------------------------------------------------------------
 */
extern int hashoid PROTO(());

/* -----------------------------------------------------------------------
 * Function:    hashclear
 * Arguments:   struct Hashnode	*hashtab[];
 * Purpose:     Clears the hashtable
 * Remarks:     
 * -----------------------------------------------------------------------
 */
extern void	hashclear PROTO(());

extern struct Hashnode *hashtab[];	/* the hash table */
#endif
