/* -----------------------------------------------------------------------
 *
 * Project:		UT-SNMP
 *
 * Filename:    spmTIM.h
 *
 * Date:        May 1994
 *
 * Purpose:		headerfile for spmTransport.c
 *
 * Author(s):	Vincent Berkhout, Frederic P. H. van Hengstum
 *
 * -----------------------------------------------------------------------
 */

#ifndef SPMTIM_H
#define SPMTIM_H

#include <snmpTypes.h>
#include <fcntl.h>
#include <sys/param.h>	/* imports NOFILE */
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <tiuser.h>


#define MAXFILES	64	/* should be system configured */

typedef	int		THANDLE ;	/* the abstract transport handle */
typedef	struct {
	int length;
	char buf[1024*64];
} TMESSAGE ; 
typedef	unsigned char	TADDRESS ;

typedef enum {
	UDPDOMAIN	= 0,	
	CLNSDOMAIN	= 1,
	CONSDOMAIN	= 2,
	DDPDOMAIN	= 3,
	IPXDOMAIN	= 4,
	TCPDOMAIN	= 5
} TDOMAIN ;

#define	DOMAINTOTAL	6	/* last domain plus one */    

typedef struct listenEntry {
	char	*transportAddress ;	/* pointer to transport address */
	int 	handle ;		/* the identity of the handle */
	int	numberOfOpens ; 
	struct	listenEntry	*next ;	/* pointer to next entry */
} listenTable ;

typedef struct activeConnectionEntry {
	char	*localTAddress,		/* pointer to transport address */
		*remoteTAddress;	/* pointer to transport address */
	int	handle;
	struct	timeval	*lastUpdate; 	/* ppointer to the time since last update */
	struct 	activeConnectionEntry	*next;	/* pointer to next entry */
} activeConnectionsTable ;
	
static int SNMP_DEBUG_TIM = 30;

/*
 *      The transport layer interface related errno ...
 */
EXTERN int	errno, t_errno;
EXTERN char	*sys_errlist[], *t_errlist[];	

#endif /* ! SPMTIM_H */

/*--------------------------- end of file spmTrans.h ------------------------------*/
