/*
 *   snmpv1_per.c
 *
 *    "RFC1157-SNMP" ASN.1 module encode/decode/print/free C src.
 *
 *    This file was generated by snacc on Thu Apr  7 15:24:33 1994
 *
 *    UBC snacc written by Mike Sample
 *
 *    NOTE: This is a machine generated file - editing not recommended
 */



#include <rfc1157_snmp.h>
#include <perv2/per_buf.h>
#include <perv2/per_bits.h>
#include <perv2/per_int.h>
#include <perv2/per_len.h>
#include <perv2/per_octs.h>
#include <perv2/per_oid.h>
#include <perv1/perVarBindV1.h>
#include <snmpTypes.h> 


AsnLen
PerEncMessageV1Choice(BUF_TYPE b, MessageV1Choice* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    switch(v->choiceId)
    {
       case(MESSAGEV1CHOICE_GET_REQUEST):
    itemLen = v->a.get_request->octetLen;
    
    totalLen += itemLen;

    break;

       case(MESSAGEV1CHOICE_GET_NEXT_REQUEST):
    itemLen = v->a.get_next_request->octetLen;
    totalLen += itemLen;

    break;

       case(MESSAGEV1CHOICE_GET_RESPONSE):
    itemLen = v->a.get_response->octetLen;
    totalLen += itemLen;

    break;

       case(MESSAGEV1CHOICE_SET_REQUEST):
    itemLen = v->a.set_request->octetLen;
    totalLen += itemLen;

    break;

       case(MESSAGEV1CHOICE_TRAP):
    itemLen = v->a.trap->octetLen;
    totalLen += itemLen;

    break;

    }
    return (totalLen);

}  /* PerEncMessageV1Choice */

	STATUS
PerDecMessageV1Choice(BUF_TYPE b,MessageV1Choice* v)
{
    AsnLen totalElmtsLen = 0;
    AsnLen elmtVal;

	PerDecLenCons(b, &elmtVal, 5);

	totalElmtsLen++;

    switch(elmtVal)
    {
       case(0):
        (v->choiceId) = MESSAGEV1CHOICE_GET_REQUEST;
    (v->a.get_request) = (AsnOcts*) Asn1Alloc(sizeof(AsnOcts));
    v->a.get_request->octs = *b; 
    v->a.get_request->octetLen = 0;/* I really don't know  the length, tough luck!!*/

    break;

       case(1):
        (v->choiceId) = MESSAGEV1CHOICE_GET_NEXT_REQUEST;
    (v->a.get_next_request) = (AsnOcts*) Asn1Alloc(sizeof(AsnOcts));
    v->a.get_next_request->octs = *b;
    v->a.get_next_request->octetLen = 0;
  
    break;

       case(2):
        (v->choiceId) = MESSAGEV1CHOICE_GET_RESPONSE;
    (v->a.get_response) = (AsnOcts*) Asn1Alloc(sizeof(AsnOcts));
	v->a.get_response->octs = *b; 
	v->a.get_response->octetLen = 0;

	break;

       case(3):
        (v->choiceId) = MESSAGEV1CHOICE_SET_REQUEST;
    (v->a.set_request) = (AsnOcts*) Asn1Alloc(sizeof(AsnOcts));
	v->a.set_request->octs = *b; 
	v->a.set_request->octetLen = 0;
  
    break;

       case(4):
        (v->choiceId) = MESSAGEV1CHOICE_TRAP;
    (v->a.trap) = (AsnOcts*) Asn1Alloc(sizeof(AsnOcts));
	v->a.trap->octs = *b;
	v->a.trap->octetLen = 0;
 
    break;

	default:
		Asn1Error("ERROR - unexpected PER tag in CHOICE\n");
    	return( ERROR );
    break;
    } /* end switch */
    return( OK );
}  /* PerDecMessageV1Choice */



AsnLen
PerEncPDUV1(BUF_TYPE b, PDUV1* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    itemLen = PerEncVarBindListV1( b, (v->variable_bindings), &listLen);
    itemLen += PerEncLenDeter(b, &listLen, 1); 

    totalLen += itemLen;

    itemLen = PerEncSInt( b, (&v->error_index));
    itemLen += PerEncLenDeter(b, &itemLen, 1);

    totalLen += itemLen;

    PerEncLenCons( b, (v->error_status), 5);
    /* shift of 5 because range of error_status is 6 */
    itemLen++;

    totalLen += itemLen;

    itemLen = PerEncSInt( b, (&v->request_id));
    itemLen += PerEncLenDeter(b, &itemLen, 1);

    totalLen += itemLen;

    return (totalLen);

}  /* PerEncPDUV1 */

	STATUS
PerDecPDUV1(BUF_TYPE b, PDUV1* v)
{
    AsnLen totalElmtsLen = 0;
    AsnLen elmtLen;
    AsnLen listLen;


    totalElmtsLen += PerDecLenDeter(b, &elmtLen, 1);
    totalElmtsLen += elmtLen;
    PerDecSInt(b, (&v->request_id), elmtLen);/* Een signed integer!!!*/


    PerDecLenCons (b, (&v->error_status), 5);
    /* shift of 5 because range of error_status is 6 */
    totalElmtsLen++;

    totalElmtsLen += PerDecLenDeter (b, &elmtLen, 1);
    totalElmtsLen += elmtLen;
    PerDecSInt(b, (&v->error_index), elmtLen); /* Een signed integer!!!*/

    totalElmtsLen += PerDecLenDeter (b, &listLen, 1);
    (v->variable_bindings) = AsnListNew(sizeof(char*));
    PerDecVarBindListV1 ( b, (v->variable_bindings), listLen);
    return( OK );
}  /* PerDecPDUV1 */


AsnLen
PerEncTrap_PDUV1(BUF_TYPE b,Trap_PDUV1* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    itemLen = PerEncVarBindListV1( b, (v->variable_bindings), &listLen);
    itemLen += PerEncLenDeter(b, &listLen, 1);
    
    totalLen += itemLen;

    itemLen = PerEncUInt( b, (&v->time_stamp));
    itemLen += PerEncLenDeter(b, &itemLen, 1);

    totalLen += itemLen;

    itemLen = PerEncSInt( b, (&v->specific_trap));
    itemLen += PerEncLenDeter(b, &itemLen, 1);

    totalLen += itemLen;

    PerEncLenCons( b, (v->generic_trap), 5);
    /* shift of 5 because range of generic_trap is 7 */
    itemLen++;

    totalLen += itemLen;

    itemLen = PerEncOcts( b, (&v->agent_addr));
    /*
     * NO length field needed SIZE is always 4
     */
    totalLen += itemLen;

    itemLen = PerEncOid( b, (&v->enterprise));
    itemLen += PerEncLenDeter( b, &itemLen, 1);

    totalLen += itemLen;

    return (totalLen);

}  /* PerEncTrap_PDUV1 */

	STATUS
PerDecTrap_PDUV1(BUF_TYPE b, Trap_PDUV1* v)
{
    AsnLen totalElmtsLen = 0;
    AsnLen elmtLen;
    AsnLen listLen;


    totalElmtsLen += PerDecLenDeter(b, &elmtLen, 1);
    totalElmtsLen += elmtLen;
    PerDecOid( b, (&v->enterprise), elmtLen);

    PerDecOcts( b, (&v->agent_addr), 4);
 	/* length is always 4 !!!*/

    PerDecLenCons( b, (&v->generic_trap), 5);
    /* shift of 5 because generic_trap has range of 7 */
    totalElmtsLen++;

    totalElmtsLen += PerDecLenDeter(b, &elmtLen, 1);
    totalElmtsLen += elmtLen;
    PerDecSInt( b, (&v->specific_trap), elmtLen);

    totalElmtsLen += PerDecLenDeter(b, &elmtLen, 1);
    totalElmtsLen += elmtLen;
    PerDecUInt( b, (&v->time_stamp), elmtLen);
   
    totalElmtsLen += PerDecLenDeter (b, &listLen, 1); 
    (v->variable_bindings) = AsnListNew(sizeof(char*));
    PerDecVarBindListV1( b, (v->variable_bindings), listLen);
    return( OK );
}  /* PerDecTrap_PDUV1 */


	AsnLen	
PerEncMessageV1(BUF_TYPE b, MessageV1* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    itemLen = PerEncMessageV1Choice( b, (v->data));

    totalLen += itemLen;

    itemLen = PerEncOcts( b, (&v->community));
    itemLen += PerEncLenDeter( b, &itemLen, 1);

    totalLen += itemLen;

    /* NO VERSION NUMBER ENCODED !!! 
       because only one value */
    return (totalLen);

}  /* PerEncMessageV1 */

	STATUS
PerDecMessageV1(BUF_TYPE b, MessageV1* v)
{
    AsnLen totalElmtsLen = 0;
    AsnLen elmtLen;


    (v->version) = 0;
    totalElmtsLen = PerDecLenDeter(b, &elmtLen, 1); 
	totalElmtsLen += elmtLen;
    PerDecOcts(b, (&v->community), elmtLen);

    (v->data) = (MessageV1Choice*) Asn1Alloc(sizeof(MessageV1Choice));
    
    PerDecMessageV1Choice( b, (v->data));
	return(OK);
}  /* PerDecMessageV1 */



AsnLen
PerEncPDUsV1(BUF_TYPE b, PDUsV1* v)
{
    AsnLen totalLen = 0;
    AsnLen itemLen;
    AsnLen listLen;
    void* component;

    switch(v->choiceId)
    {
       case(PDUSV1_GET_REQUEST):
    itemLen = PerEncPDUV1( b, (v->a.get_request));
    PerEncLenCons( b, 0, 5); 
    itemLen++;
    
    totalLen += itemLen;

    break;

       case(PDUSV1_GET_NEXT_REQUEST):
    itemLen = PerEncPDUV1( b, (v->a.get_next_request));
    PerEncLenCons( b, 1, 5);

    itemLen++;

    totalLen += itemLen;

    break;

       case(PDUSV1_GET_RESPONSE):
    itemLen = PerEncPDUV1( b, (v->a.get_response));
    PerEncLenCons( b, 2, 5);

    itemLen++;

    totalLen += itemLen;

    break;

       case(PDUSV1_SET_REQUEST):
    itemLen = PerEncPDUV1( b, (v->a.set_request));
    PerEncLenCons( b, 3, 5);

    itemLen++;

    totalLen += itemLen;

    break;

       case(PDUSV1_TRAP):
    itemLen = PerEncTrap_PDUV1( b, (v->a.trap));
    PerEncLenCons( b, 3, 5); 

    itemLen++;
    
    totalLen += itemLen;

    break;

    }
    return (totalLen);

}  /* PerEncPDUsV1 */

	STATUS
PerDecPDUsV1(BUF_TYPE b, PDUsV1* v, PDUsChoiceId tag)
{
    AsnLen totalElmtsLen = 0;
    AsnLen elmtLen;


    switch(tag)
    {
	   case(PDUSV1_GET_REQUEST):
        (v->choiceId) = PDUSV1_GET_REQUEST;
    (v->a.get_request) = (GetRequest_PDUV1*) Asn1Alloc(sizeof(GetRequest_PDU));
    PerDecPDUV1( b, (v->a.get_request));
    break;

       case(PDUSV1_GET_NEXT_REQUEST):
        (v->choiceId) = PDUSV1_GET_NEXT_REQUEST;
    (v->a.get_next_request) = (GetNextRequest_PDUV1*) Asn1Alloc(sizeof(GetNextRequest_PDUV1));
    PerDecPDUV1( b, (v->a.get_next_request));
    break;

       case(PDUSV1_GET_RESPONSE):
        (v->choiceId) = PDUSV1_GET_RESPONSE;
    (v->a.get_response) = (GetResponse_PDUV1*) Asn1Alloc(sizeof(GetResponse_PDUV1));
    PerDecPDUV1( b, (v->a.get_response));
    break;

       case(PDUSV1_SET_REQUEST):
        (v->choiceId) = PDUSV1_SET_REQUEST;
    (v->a.set_request) = (SetRequest_PDUV1*) Asn1Alloc(sizeof(SetRequest_PDUV1));
    PerDecPDUV1( b, (v->a.set_request));
    break;

       case(PDUSV1_TRAP):
        (v->choiceId) = PDUSV1_TRAP;
    (v->a.trap) = (Trap_PDUV1*) Asn1Alloc(sizeof(Trap_PDUV1));
    PerDecTrap_PDUV1( b, (v->a.trap));
    break;

    default:
        Asn1Error("ERROR - unexpected PER tag in CHOICE\n");
        return( ERROR );
	break;
    } /* end switch */
	return( OK );
}  /* PerDecPDUsV1 */


